//
//  NSDictionaryTransformer.m
//  CocoaBeam
//
//  Created by Jake on 3/30/07.
//  Copyright 2007 __MyCompanyName__. All rights reserved.
//

#import "CBDictionaryTransformer.h"

@implementation CBDictionaryTransformer

+ (Class)transformedValueClass {
    return [NSArray class];
}

+ (BOOL)allowsReverseTransformation {
    return YES;
}

- (id)transformedValue:(id)value {
    NSMutableArray *array = [NSMutableArray array];

	NSEnumerator* enumerator = [[value allKeys] objectEnumerator];
	NSString* key;
	while (key = [enumerator nextObject]) {
		id object = [value valueForKey:key];
		if ([object isKindOfClass:[NSNumber class]]) {
        	[array addObject:[NSMutableDictionary dictionaryWithObjectsAndKeys:
	            key, @"key",
	            object, @"value", nil]];
		}
    }
    return array;
}

- (id)reverseTransformedValue:(id)value {
    NSMutableDictionary *dictionary = [NSMutableDictionary dictionary];

	NSEnumerator* enumerator = [value objectEnumerator];
	NSMutableDictionary *keyValuePair;
	while (keyValuePair = [enumerator nextObject]) {
        [dictionary setValue:[keyValuePair valueForKey:@"value"]
                      forKey:[keyValuePair valueForKey:@"key"]];
    }
    return dictionary;
}

@end
