//
//  CBGeometricModel.h
//  CocoaBeam
//
//  Created by Jake on 3/23/07.
//  Copyright 2007 __MyCompanyName__. All rights reserved.
//

#import <Cocoa/Cocoa.h>
#include "math.h"

#define RADIANS(degrees) degrees/(180/pi)
#define DEGREES(radians) radians*(180/pi)

@interface CBGeometricModel : NSObject {
	float trimHeight;
	float floorDistance;
	float focusHeight;
	
	NSSize desiredArea;
}

- (float)trimHeight;
- (void)setTrimHeight:(float)newTrimHeight;
- (float)floorDistance;
- (void)setFloorDistance:(float)newFloorDistance;
- (float)focusHeight;
- (void)setFocusHeight:(float)newFocusHeight;

- (float)angleOfIncidence;
- (float)throwDistance;

- (float)floorWidthForAngle:(float)angle;
- (float)floorPointForAngleOffset:(float)angle;

- (NSSize)desiredArea;
- (void)setDesiredArea:(NSSize)newDesiredArea;
- (float)desiredAreaWidth;
- (void)setDesiredAreaWidth:(float)newDesiredAreaWidth;
- (float)desiredAreaHeight;
- (void)setDesiredAreaHeight:(float)newDesiredAreaHeight;
@end
