//
//  CBIntensityCurveView.m
//  CocoaBeam
//
//  Created by Jake on 4/5/07.
//  Copyright 2007 __MyCompanyName__. All rights reserved.
//

#import "CBIntensityCurveView.h"
#import "CBFixture.h"

@implementation CBIntensityCurveView

- (id)initWithFrame:(NSRect)frame {
    self = [super initWithFrame:frame];
    if (self) {
        // Initialization code here.
    }
    return self;
}

- (void)drawRect:(NSRect)rect {
	//Background is black
	[[NSColor blackColor] set];
	NSRectFill(rect);

	//Fixture Properties
	float maxAngle = MAX([fixture angleXForIntensity:0.0],[fixture angleYForIntensity:0.0]);

	//Transform
	float xscale = rect.size.width/maxAngle;
	float yscale = rect.size.height;
		
	//draw horizontal gridlines
	NSBezierPath* line = [NSBezierPath bezierPath];

	float y;
	for (y=0.1; y<1.0; y+=0.1) {
		[line moveToPoint:NSMakePoint(0,y*yscale)];
		[line lineToPoint:NSMakePoint(rect.size.width,y*yscale)];
	}	
	[[NSColor grayColor] set];
	[line stroke];
			

		
	NSBezierPath* xpath = nil;
	NSBezierPath* ypath = nil;
	float intensity;
	for (intensity=1.0; intensity>=0.0; intensity-=0.05) {
		float xangle =[fixture angleXForIntensity:intensity];
		float yangle =[fixture angleYForIntensity:intensity];
		if (!xpath) {
			xpath = [NSBezierPath bezierPath];
			[xpath moveToPoint:NSMakePoint(xangle*xscale,intensity*yscale)];
		} else 	[xpath lineToPoint:NSMakePoint(xangle*xscale,intensity*yscale)];
		if (!ypath) {
			ypath = [NSBezierPath bezierPath];
			[ypath moveToPoint:NSMakePoint(yangle*xscale,intensity*yscale)];
		} else 	[ypath lineToPoint:NSMakePoint(yangle*xscale,intensity*yscale)];
	}
	
	//draw beamAngle/fieldAngle verticals
	[[NSColor redColor] set];
	[xpath stroke];
	[[NSColor greenColor] set];
	[ypath stroke];
	
	[xpath removeAllPoints];
	[ypath removeAllPoints];
	[xpath moveToPoint:NSMakePoint([fixture beamAngleX]*xscale,0.0)];
	[xpath lineToPoint:NSMakePoint([fixture beamAngleX]*xscale,rect.size.height)];	
	[xpath moveToPoint:NSMakePoint([fixture fieldAngleX]*xscale,0.0)];
	[xpath lineToPoint:NSMakePoint([fixture fieldAngleX]*xscale,rect.size.height)];
	[ypath moveToPoint:NSMakePoint([fixture beamAngleY]*xscale,0.0)];
	[ypath lineToPoint:NSMakePoint([fixture beamAngleY]*xscale,rect.size.height)];	
	[ypath moveToPoint:NSMakePoint([fixture fieldAngleY]*xscale,0.0)];
	[ypath lineToPoint:NSMakePoint([fixture fieldAngleY]*xscale,rect.size.height)];
	
	[[[NSColor redColor] shadowWithLevel:0.5] set];
	[xpath stroke];
	[[[NSColor greenColor] shadowWithLevel:0.5] set];
	[ypath stroke];

}

- (CBFixture*)fixture {
	return fixture;
}

- (void)observeValueForKeyPath:(NSString *)keyPath
              ofObject:(id)object 
                        change:(NSDictionary *)change
                       context:(void *)context {
	[self display];
}

- (void)setFixture:(CBFixture*)aValue {
	CBFixture* oldFixture = fixture;
	fixture = [aValue retain];
	[oldFixture release];
	[self display];
}
@end
