//
//  NSBezierPath+Gradient.m
//  CocoaBeam
//
//  Created by Jake on 3/24/07.
//  Copyright 2007 __MyCompanyName__. All rights reserved.
//

#import "NSBezierPath+Gradient.h"

@implementation NSBezierPath(MRGradientFill) 

void Interpolate (void* info, float const* inData, float* outData)
{
	NSColor* color = (NSColor*)info;
    float position = *inData;
	[color getRed:&outData[0] green:&outData[1] blue:&outData[2] alpha:&outData[3]];
    //outData[0] *= position; 
    //outData[1] *= position;
    //outData[2] *= position;
	outData[3] *= position;
}

-(void)linearGradientFill:(NSColor*)startColor {

	struct CGFunctionCallbacks callbacks = { 0, Interpolate, NULL };

	CGFunctionRef function = CGFunctionCreate(
		startColor,       // void* info,
		1,          // size_t domainDimension,
		NULL,       // float const* domain,
		4,          // size_t rangeDimension,
		NULL,       // float const* range,
		&callbacks  // CGFunctionCallbacks const* callbacks
		);

	CGColorSpaceRef cspace = CGColorSpaceCreateDeviceRGB();
	NSRect bounds = [self bounds];
	CGShadingRef shading = CGShadingCreateAxial( cspace,
	   CGPointMake(bounds.origin.x, bounds.origin.y+(bounds.size.height/2)),
	   CGPointMake([self bounds].origin.x+[self bounds].size.width, bounds.origin.y+(bounds.size.height/2)),
	   function,
	   NO, NO);

    CGContextRef context = (CGContextRef)[[NSGraphicsContext currentContext] graphicsPort];
	[self setClip];
	
    CGContextDrawShading(context, shading);

    CGShadingRelease(shading);
    CGColorSpaceRelease(cspace);
    CGFunctionRelease(function);
	
}

@end